#include <pspsdk.h>
#include <pspkernel.h>
#include <systemctrl.h>
#include <string.h>

PSP_MODULE_INFO("slim_colors", 0x1007, 0, 1);
STMOD_HANDLER previous = NULL;

typedef struct
{
	u32 devkit;
	u32 address;
} patch;

patch patches[] =
{
	{ 0x05000010, 0x6114 },
	{ 0x04000110, 0x5730 },
	{ 0x03090010, 0x2788 },
};

int OnModuleStart(SceModule2 *mod)
{
	if (strcmp(mod->modname, "sysconf_plugin_module") == 0)
	{
		int i;
		u32 devkit = sceKernelDevkitVersion();
		
		for (i = 0; i < sizeof(patches)/sizeof(patch); i++)
		{
			if (devkit == patches[i].devkit)
			{
				u32 addr = mod->text_addr+patches[i].address;
				
				_sw(_lw(addr+4), addr);
				_sw(0x24020001, addr+4);
				
				break;
			}
		}
		
		sceKernelDcacheWritebackAll();
		sceKernelIcacheClearAll();
	}

	if (!previous)
		return 0;
		
	return previous(mod);
}

int module_start(SceSize args, void *argp)
{
	previous = sctrlHENSetStartModuleHandler(OnModuleStart);
	return 0;
}